/*
BUILD INFO:
  dir: dev
  target: main.js
  files: 8
*/



// file: blockType.js

var BLOCK_TYPE_STONE = Block.createSpecialType({
	base: 1,
	opaque: true
});
var BLOCK_TYPE_LIGHT = Block.createSpecialType({
	base: 5,
	opaque: true,
	lightlevel:15
});
var BLOCK_TYPE_WOOD = Block.createSpecialType({
	base: 5,
	opaque: true
});




// file: furnitureCore.js

function createFurnitureWood(stringId,textureItem, textureBlock, textureIndex,itemName, itemId, blockId, itemIndex){
IDRegistry.genBlockID(stringId);
Block.createBlock(stringId, [
	{name: itemName, texture: [[textureBlock, textureIndex]], inCreative: false}
],BLOCK_TYPE_WOOD);
IDRegistry.genItemID(stringId);
Item.createItem(stringId, itemName, {name: textureItem, meta: itemIndex}, {});

Block.registerDropFunction(stringId, function(coords, id, data, diggingLevel, toolLevel){
	return [[itemId, 1, 0]]; 
});
Item.registerUseFunction(stringId, function(coords, item, block){
	World.setBlock(coords.relative.x,coords.relative.y,coords.relative.z, blockId);
});
}
function createFurnitureLight(stringId,textureItem, textureBlock, textureIndex,itemName, itemId, blockId){
IDRegistry.genBlockID(stringId);
Block.createBlock(stringId, [
	{name: itemName, texture: [[textureBlock, textureIndex]], inCreative: false}
],BLOCK_TYPE_LIGHT);
IDRegistry.genItemID(stringId);
Item.createItem(stringId, itemName, {name: textureItem, meta: 0}, {});

Block.registerDropFunction(stringId, function(coords, id, data, diggingLevel, toolLevel){
	return [[itemId, 1, 0]]; 
});
}
function createFurnitureStone(stringId,textureItem, textureBlock, textureIndex,itemName, itemId, blockId, itemIndex){
IDRegistry.genBlockID(stringId);
Block.createBlock(stringId, [
	{name: itemName, texture: [[textureBlock, textureIndex]], inCreative: false}
],BLOCK_TYPE_STONE);
IDRegistry.genItemID(stringId);
Item.createItem(stringId, itemName, {name: textureItem, meta: itemIndex}, {});

Block.registerDropFunction(stringId, function(coords, id, data, diggingLevel, toolLevel){
	if(toolLevel>0){
		return [[itemId, 1, 0]]; 
	}else{
		return [[0,0,0]];
	}
	
});
Item.registerUseFunction(stringId, function(coords, item, block){
	World.setBlock(coords.relative.x,coords.relative.y,coords.relative.z, blockId);
});
}

function createFurnitureStoneRotation(stringId,textureItem, textureBlock, textureIndex,itemName, itemId, blockId){
IDRegistry.genBlockID(stringId);
Block.createBlockWithRotation(stringId, [
	{name: itemName, texture: [[textureBlock, textureIndex]], inCreative: false}
],BLOCK_TYPE_STONE);
IDRegistry.genItemID(stringId);
Item.createItem(stringId, itemName, {name: textureItem, meta: 0}, {});

Block.registerDropFunction(stringId, function(coords, id, data, diggingLevel, toolLevel){
	if(toolLevel>0){
		return [[itemId, 1, 0]]; 
	}else{
		return [[0,0,0]];
	}
	
});
Item.registerUseFunction(stringId, function(coords, item, block){
	World.setBlock(coords.relative.x,coords.relative.y,coords.relative.z, blockId);
});
}




// file: modelAPI.js

var ModelAPI={
	newArray:function(){
		return {
			addBoxByID:function(idBox, pointx1, pointy1, pointz1, pointx2, pointy2, pointz2, id, data){
		if(data == undefined){
			data=0;
		}
		if(id==undefined){
			return false;
		}else{
			this.box.push({idBox:idBox,x1:pointx1, y1:pointy1, z1:pointz1, x2:pointx2, y2:pointy2, z2:pointz2, id:id, data:data, type:"block"});
		}
	},
	addBoxByTexture:function(idBox, pointx1, pointy1, pointz1, pointx2, pointy2, pointz2, textureName, index){
		if(index == undefined){
			index=0;
		}
		if(textureName==undefined){
			return false;
		}else{
			this.box.push({idBox:idBox,x1:pointx1, y1:pointy1, z1:pointz1, x2:pointx2, y2:pointy2, z2:pointz2, textureName:textureName, index:index, type:"texture"});
		}
	},
	addBoxByTextures:function(idBox, pointx1, pointy1, pointz1, pointx2, pointy2, pointz2, textureArray){
		if(textureArray==undefined){
			return false;
		}else{
			this.box.push({idBox:idBox,x1:pointx1, y1:pointy1, z1:pointz1, x2:pointx2, y2:pointy2, z2:pointz2, textureArray:textureArray, type:"textureArray"});
		}
	},
	boxById:function(id){
		for(var i in this.box){
			if(this.box[i].idBox==id){
				return this.box[i];
			}
		}
		return null;
	},
	deleteBox:function(id){
		if((typeof id)=="string"){
		for(var i in this.box){
			if(this.box[i].idBox==id){
				this.box.splice(i,1);
				return true;
				}
			}
		}else if((typeof id)=="object"){
			for(var i in this.box){
				for(var b in id){
				if(this.box[i].idBox==id[b]){
				this.box.splice(i,1);
				}
			}
		}
	}
		
		return false;
	},
	generateId:function(){
		return ""+this.box.lentgh;
	},
	mirrorBoxTech:function(box, orientation){
		if(box.type=="block"){
					this.box.push({x1:orientation.x+(orientation.x-box.x2),y1:orientation.y+(orientation.y-box.y2),z1:orientation.z+(orientation.z-box.z2),
					x2:orientation.x+(orientation.x-box.x1),y2:orientation.y+(orientation.y-box.y1),z2:orientation.z+(orientation.z-box.z1),id:box.id, data:box.data, type:"block"
					});
				}else if(box[i].type=="texture"){
					this.box.push({x1:orientation.x+(orientation.x-box.x2),y1:orientation.y+(orientation.y-box.y2),z1:orientation.z+(orientation.z-box.z2),
					x2:orientation.x+(orientation.x-box.x1),y2:orientation.y+(orientation.y-box.y1),z2:orientation.z+(orientation.z-box.z1),textureName:box.textureName, index:box.index, type:"texture"
					});
				}else{
					this.box.push({x1:orientation.x+(orientation.x-box.x2),y1:orientation.y+(orientation.y-box.y2),z1:orientation.z+(orientation.z-box.z2),
					x2:orientation.x+(orientation.x-box.x1),y2:orientation.y+(orientation.y-box.y1),z2:orientation.z+(orientation.z-box.z1),textureArray:box.textureArray, type:"textureArray"
					});
				}
	},
	mirror:function(box, orientation){
		if(orientation==undefined){
			var orientation={x:0,y:0,z:0};
		}
		if(box=="all"){
			var box = this.box;
			for(var i in box){
				this.mirrorBoxTech(box[i],orientation);
			}
		}else if((typeof box)=="string"){
			this.mirrorBoxTech(this.boxById(box), orientation);
		}else{
			for(var g in box){
				for(var i in this.box){
					if(this.box[i].idBox==box[g]){
						this.mirrorBoxTech(box[g], orientation);
					}
				}
				
			}
		}
	},
	mirrorBoxTechX:function(box, orientation){
		var x1= box.x1;
		var x2 = box.x2;
		box.x2 = 2*orientation.x-x1;
		box.x1 = 2*orientation.x-x2;
	},
	mirrorX:function(box, orientation){
		if(orientation==undefined){
			var orientation={x:0,y:0,z:0};
		}
		if(box=="all"){
			var box = this.box;
			for(var i in box){
				this.mirrorBoxTechX(box[i],orientation);
			}
		}else if((typeof box)=="string"){
			this.mirrorBoxTechX(this.boxById(box), orientation);
		}else{
			for(var g in box){
				for(var i in this.box){
					if(this.box[i].idBox==box[g]){
						this.mirrorBoxTechX(box[g], orientation);
					}
				}
				
			}
		}
	},
	mirrorBoxTechY:function(box, orientation){
		var y1= box.y1;
		var y2 = box.y2;
		box.y2 = 2*orientation.y-y1;
		box.y1 = 2*orientation.y-y2;
	},
	mirrorY:function(box, orientation){
		if(orientation==undefined){
			var orientation={x:0,y:0,z:0};
		}
		if(box=="all"){
			var box = this.box;
			for(var i in box){
				this.mirrorBoxTechY(box[i],orientation);
			}
		}else if((typeof box)=="string"){
			this.mirrorBoxTechY(this.boxById(box), orientation);
		}else{
			for(var g in box){
				for(var i in this.box){
					if(this.box[i].idBox==box[g]){
						this.mirrorBoxTechY(box[g], orientation);
					}
				}
				
			}
		}
	},
	mirrorBoxTechZ:function(box, orientation){
		var z1= box.z1;
		var z2 = box.z2;
		box.z2 = 2*orientation.z-z1;
		box.z1 = 2*orientation.z-z2;
	},
	mirrorZ:function(box, orientation){
		if(orientation==undefined){
			var orientation={x:0,y:0,z:0};
		}
		if(box=="all"){
			var box = this.box;
			for(var i in box){
				this.mirrorBoxTechZ(box[i],orientation);
			}
		}else if((typeof box)=="string"){
			this.mirrorBoxTechZ(this.boxById(box), orientation);
		}else{
			for(var g in box){
				for(var i in this.box){
					if(this.box[i].idBox==box[g]){
						this.mirrorBoxTechZ(box[g], orientation);
					}
				}
				
			}
		}
	},
	copyBox:function(box, newId){
		var block ={};
		for (var key in box) {
  			block[key] = box[key];
		}
		if(newId){
			block.idBox=newId;
		}else{
			block.idBox="Copied";
		}
		this.box.push(block);
		return this.box[this.box.length-1];
	},
	rotationTech:function(box, orientation, angle, point){
		if(orientation=="y"){
			if(angle==90){
				var tech = 0;
				tech = box.x1;
				box.x1=box.z1;
				box.z1=tech;
				tech = box.x2;
				box.x2=box.z2;
				box.z2=tech;
				this.mirrorX(box.idBox, {x:point.x, y:point.y, z:point.z});
				this.mirrorZ(box.idBox, {x:point.x, y:point.y, z:point.z});
			}
			if(angle==180){
				this.mirrorX(box.idBox, {x:point.x, y:point.y, z:point.z});
				this.mirrorZ(box.idBox, {x:point.x, y:point.y, z:point.z});
			}
			if(angle==270){
				var tech = 0;
				tech = box.x1;
				box.x1=-box.z1;
				box.z1=-tech;
				tech = box.x2;
				box.x2=-box.z2;
				box.z2=-tech;
				box.x1+point.x;
				box.x2+point.x;
				box.z1+point.z;
				box.z2+point.z;
			}
		}
		if(orientation=="x"){
			if(angle==90){
				var tech = 0;
				tech = box.y1;
				box.y1=box.z1;
				box.z1=tech;
				tech = box.y2;
				box.y2=box.y2;
				box.z2=tech;
				this.mirrorY(box.idBox, {x:point.x, y:point.y, z:point.z});
				this.mirrorZ(box.idBox, {x:point.x, y:point.y, z:point.z});
			}
			if(angle==180){
				this.mirrorY(box.idBox, {x:point.x, y:point.y, z:point.z});
				this.mirrorZ(box.idBox, {x:point.x, y:point.y, z:point.z});
			}
			if(angle==270){
				var tech = 0;
				tech = box.y1;
				box.y1=-box.z1;
				box.z1=-tech;
				tech = box.y2;
				box.y2=-box.z2;
				box.z2=-tech;
				box.y1+point.y;
				box.y2+point.y;
				box.z1+point.z;
				box.z2+point.z;
			}
		}
		if(orientation=="z"){
			if(angle==90){
				var tech = 0;
				tech = box.x1;
				box.x1=box.y1;
				box.y1=tech;
				tech = box.x2;
				box.x2=box.y2;
				box.y2=tech;
				this.mirrorX(box.idBox, {x:point.x, y:point.y, z:point.z});
				this.mirrorY(box.idBox, {x:point.x, y:point.y, z:point.z});
			}
			if(angle==180){
				this.mirrorX(box.idBox, {x:point.x, y:point.y, z:point.z});
				this.mirrorY(box.idBox, {x:point.x, y:point.y, z:point.z});
			}
			if(angle==270){
				var tech = 0;
				tech = box.x1;
				box.x1=-box.y1;
				box.y1=-tech;
				tech = box.x2;
				box.x2=-box.y2;
				box.y2=-tech;
				box.x1+point.x;
				box.x2+point.x;
				box.y1+point.y;
				box.y2+point.y;
			}
		}
	},
	rotation:function(id, orientation, angle, point){
		if(id=="all"){
			for(var i in this.box){
				this.rotationTech(this.box[i],orientation,angle,point);
			}
		}else if((typeof id)=="string"){
			this.rotationTech(this.boxById(id),orientation,angle,point);
		}else{
			for(var g in id){
				for(var i in this.box){
					if(this.box[i].idBox==id[g]){
						this.mirrorBoxTechZ(id[g], orientation);
					}
				}
			}
		}
	},
	checkInersection:function(box1, box2){
		if(box1.x1<box2.x2&&box1.x2>box2.x1||box1.x1>box2.x1&&box1.x2<box2.x2){
			if(box1.y1<box2.y2&&box1.y2>box2.y1||box1.y1>box2.y1&&box1.y2<box2.y2){
				if(box1.z1<box2.z2&&box2.z1>box2.z1||box1.z1>box2.z1&&box1.z2<box2.z2){
					box1.type="block";
					box1.id = 152;
					box1.data = 0;
					box2.id = 152;
					box2.data = 0;
					box2.type="block";
				}
			}
		}
	},
	debugMode:function(){
		for(var i in this.box){
			for(var t in this.box){
				if(i!=t){
				this.checkInersection(this.box[i], this.box[t]);
				}
			}
		}
	}, 
	copyModel:function(model){
		for(var i in this.box){
			var block ={};
			for (var key in box) {
  				block[key] = box[key];
			}	
			model.box.push(block);
		}
	},
	compile:function(model){
		for(var i in this.box){
			var m= this.box[i];
			if(m.idBox!=undefined){
			if(m.type=="block"){
				model.addBox(m.x1, m.y1, m.z1, m.x2, m.y2, m.z2, m.id, m.data);
				
			}else if(m.type=="texture"){
				model.addBox(m.x1, m.y1, m.z1, m.x2, m.y2, m.z2, m.textureName, m.index);
			}else if(m.type=="textureArray"){
				model.addBox(m.x1, m.y1, m.z1, m.x2, m.y2, m.z2, m.textureArray);
			}
		}
		}
	},
	box:[]
		};
	}
};







// file: Table.js

function createTableRender(id, idMaterial, dataMaterial){
var render = new ICRender.Model();
BlockRenderer.setStaticICRender (id, 0, render);
var model = BlockRenderer.createModel();

model.addBox (6/16, 0, 6/16, 10/16, 0.95, 10/16,  idMaterial, dataMaterial);
model.addBox (0, 14/16, 0, 1, 1, 1,  idMaterial, dataMaterial);
model.addBox (4/16, 0, 1/4, 3/4, 1/32, 3/4,  idMaterial, dataMaterial);

render.addEntry(model);
}
createFurnitureWood("oakTable","table","planks",0, "Oak Table", ItemID.oakTable, BlockID.oakTable,0);
Translation.addTranslation("Oak Table", {ru: "Дубовый Стол"});
Recipes.addShaped({id: IDData.item.oakTable, count: 1, data: 0}, ["www", "vwv", "vwv"], ["w",5,0]);
createTableRender(BlockID.oakTable, 5, 0);

createFurnitureWood("birchTable","table","planks",2, "Birch Table", ItemID.birchTable, BlockID.birchTable,1);
Translation.addTranslation("Birch Table", {ru: "Берёзовый Стол"});
Recipes.addShaped({id: IDData.item.birchTable, count: 1, data: 2}, ["www", "vwv", "vwv"], ["w",5,2]);
createTableRender(BlockID.birchTable, 5, 2);

createFurnitureWood("spruceTable","table","planks",1, "Spruce Table", ItemID.spruceTable, BlockID.spruceTable,2);
Translation.addTranslation("Spruce Table", {ru: "Еловый Стол"});
Recipes.addShaped({id: IDData.item.spruceTable, count: 1, data: 1}, ["www", "vwv", "vwv"], ["w",5,1]);
createTableRender(BlockID.spruceTable, 5, 1);

createFurnitureWood("jungleTable","table","planks",3, "Jungle Table", ItemID.jungleTable, BlockID.jungleTable,3);
Translation.addTranslation("Jungle Table", {ru: "Стол из Тропической Древесины"});
Recipes.addShaped({id: IDData.item.spruceTable, count: 1, data: 3}, ["www", "vwv", "vwv"], ["w",5,3]);
createTableRender(BlockID.jungleTable, 5, 3);

createFurnitureWood("acaciaTable","table","planks",4, "Acacia Table", ItemID.acaciaTable, BlockID.acaciaTable,4);
Translation.addTranslation("Acacia Table", {ru: "Стол из Акации"});
Recipes.addShaped({id: IDData.item.acaciaTable, count: 1, data: 4}, ["www", "vwv", "vwv"], ["w",5,4]);
createTableRender(BlockID.acaciaTable, 5, 4);

createFurnitureWood("darkOakTable","table","planks",5, "Dark Oak Table", ItemID.darkOakTable, BlockID.darkOakTable,5);
Translation.addTranslation("Dark Oak Table", {ru: "Стол из Тёмного Дуба"});
Recipes.addShaped({id: IDData.item.darkOakTable, count: 1, data: 5}, ["www", "vwv", "vwv"], ["w",5,5]);
createTableRender(BlockID.darkOakTable, 5, 5);

createFurnitureStone("cobblestoneTable","table","cobblestone",0, "Cobblestone Table", ItemID.cobblestoneTable, BlockID.cobblestoneTable,6);
Translation.addTranslation("Cobblestone Table", {ru: "Стол из Булыжника"});
Recipes.addShaped({id: IDData.item.cobblestoneTable, count: 1, data: 0}, ["www", "vwv", "vwv"], ["w",4,0]);
createTableRender(BlockID.cobblestoneTable, 4, 0);

createFurnitureStone("stoneBrickTable","table","stonebrick",0, "Stone Brick Table", ItemID.stoneBrickTable, BlockID.stoneBrickTable,7);
Translation.addTranslation("Stone Brick Table", {ru: "Стол из Каменного Кирпича"});
Recipes.addShaped({id: IDData.item.stoneBrickTable, count: 1, data: 0}, ["www", "vwv", "vwv"], ["w",98,0]);
createTableRender(BlockID.stoneBrickTable, 98, 0);

createFurnitureStone("quartzTable","table","quartz_block",0, "Quartz Table", ItemID.quartzTable, BlockID.quartzTable,8);
Translation.addTranslation("Quartz Table", {ru: "Кварцевый Стол"});
Recipes.addShaped({id: IDData.item.quartzTable, count: 1, data: 0}, ["www", "vwv", "vwv"], ["w",155,0]);
createTableRender(BlockID.quartzTable, 155, 0);




// file: coffeeTable.js

function createCoffeeTableRender(id, idMaterial, dataMaterial){
var render = new ICRender.Model();
BlockRenderer.setStaticICRender (id, 0, render);
var model = BlockRenderer.createModel();

model.addBox (0, 0, 0, 2/16, 0.4, 2/16,  idMaterial, dataMaterial);
model.addBox (14/16, 0, 0, 1, 0.4, 2/16,  idMaterial, dataMaterial);
model.addBox (0, 0, 14/16, 2/16, 0.4, 1,  idMaterial, dataMaterial);
model.addBox (14/16, 0, 14/16, 1, 0.4, 1,  idMaterial, dataMaterial);

model.addBox (0, 6/16, 0, 2/16, 1/2, 1,  idMaterial, dataMaterial);
model.addBox (14/16, 6/16, 0, 1, 1/2, 1,  idMaterial, dataMaterial);
model.addBox (2/16, 6/16, 0, 14/16, 1/2, 2/16,  idMaterial, dataMaterial);
model.addBox (2/16, 6/16, 14/16, 14/16, 1/2, 1,  idMaterial, dataMaterial);

model.addBox (2/16, 7/16, 2/16, 14/16, 1/2, 14/16,  20,0);
//model.addBox (2/16, 6/16, 2/16, 14/16, 7/16, 14/16,  idMaterial, dataMaterial);

render.addEntry(model);
}
createFurnitureWood("oakCoffeeTable","cofeetable","planks",0, "Oak Coffe Table", ItemID.oakCoffeeTable, BlockID.oakCoffeeTable,0);
Translation.addTranslation("Oak Coffe Table", {ru: "Дубовый Кофейный Стол"});
Recipes.addShaped({id: IDData.item.oakCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",5,0]);
createCoffeeTableRender(BlockID.oakCoffeeTable, 5, 0);
Block.setShape(BlockID.oakCoffeeTable,0,0,0,1,1/2,1);

createFurnitureWood("spruceCoffeeTable","cofeetable","planks",1, "Spruce Coffe Table", ItemID.spruceCoffeeTable, BlockID.spruceCoffeeTable,1);
Translation.addTranslation("Spruce Coffe Table", {ru: "Еловый Кофейный Стол"});
Recipes.addShaped({id: IDData.item.spruceCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",5,1]);
createCoffeeTableRender(BlockID.spruceCoffeeTable, 5, 1);
Block.setShape(BlockID.spruceCoffeeTable,0,0,0,1,1/2,1);

createFurnitureWood("birchCoffeeTable","cofeetable","planks",2, "Birch Coffe Table", ItemID.birchCoffeeTable, BlockID.birchCoffeeTable,2);
Translation.addTranslation("Birch Coffe Table", {ru: "Берёзовый Кофейный Стол"});
Recipes.addShaped({id: IDData.item.birchCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",5,2]);
createCoffeeTableRender(BlockID.birchCoffeeTable, 5, 2);
Block.setShape(BlockID.birchCoffeeTable,0,0,0,1,1/2,1);

createFurnitureWood("jungleCoffeeTable","cofeetable","planks",3, "Jungle Coffe Table", ItemID.jungleCoffeeTable, BlockID.jungleCoffeeTable,3);
Translation.addTranslation("Jungle Coffe Table", {ru: "Кофейный Стол из Тропической Древесины"});
Recipes.addShaped({id: IDData.item.jungleCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",5,3]);
createCoffeeTableRender(BlockID.jungleCoffeeTable, 5, 3);
Block.setShape(BlockID.jungleCoffeeTable,0,0,0,1,1/2,1);

createFurnitureWood("acaciaCoffeeTable","cofeetable","planks",4, "Oak Coffe Table", ItemID.acaciaCoffeeTable, BlockID.acaciaCoffeeTable,4);
Translation.addTranslation("Acacia Coffe Table", {ru: "Кофейный Стол из Акации"});
Recipes.addShaped({id: IDData.item.acaciaCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",5,4]);
createCoffeeTableRender(BlockID.acaciaCoffeeTable, 5, 4);
Block.setShape(BlockID.acaciaCoffeeTable,0,0,0,1,1/2,1);

createFurnitureWood("darkOakCoffeeTable","cofeetable","planks",0, "Dark Oak Coffe Table", ItemID.darkOakCoffeeTable, BlockID.darkOakCoffeeTable,5);
Translation.addTranslation("Dark Oak Coffe Table", {ru: "Кофейный Стол из Тёмного Дуба"});
Recipes.addShaped({id: IDData.item.darkOakCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",5,5]);
createCoffeeTableRender(BlockID.darkOakCoffeeTable, 5, 5);
Block.setShape(BlockID.darkOakCoffeeTable,0,0,0,1,1/2,1);

createFurnitureStone("cobblestoneCoffeeTable","cofeetable","cobblestone",0, "Cobblestone Coffe Table", ItemID.cobblestoneCoffeeTable, BlockID.cobblestoneCoffeeTable,6);
Translation.addTranslation("Cobblestone Coffe Table", {ru: "Каменный Кофейный Стол"});
Recipes.addShaped({id: IDData.item.cobblestoneCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",4,0]);
createCoffeeTableRender(BlockID.cobblestoneCoffeeTable, 4, 0);
Block.setShape(BlockID.cobblestoneCoffeeTable,0,0,0,1,1/2,1);

createFurnitureStone("stoneBrickCoffeeTable","cofeetable","stonebrick",0, "Stone Brick Coffe Table", ItemID.stoneBrickCoffeeTable, BlockID.stoneBrickCoffeeTable,7);
Translation.addTranslation("Stone Brick Coffe Table", {ru: "Кофейный Стол из Каменных Кирпичей"});
Recipes.addShaped({id: IDData.item.stoneBrickCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",98,0]);
createCoffeeTableRender(BlockID.stoneBrickCoffeeTable, 98, 0);
Block.setShape(BlockID.stoneBrickCoffeeTable,0,0,0,1,1/2,1);

createFurnitureStone("quartzCoffeeTable","cofeetable","quartz_block",0, "Quartz Coffe Table", ItemID.quartzCoffeeTable, BlockID.quartzCoffeeTable,8);
Translation.addTranslation("Quartz Coffe Table", {ru: "Кварцевый Кофейный Стол"});
Recipes.addShaped({id: IDData.item.quartzCoffeeTable, count: 1, data: 0}, ["vvv", "www", "wvw"], ["w",155,0]);
createCoffeeTableRender(BlockID.quartzCoffeeTable, 155, 0);
Block.setShape(BlockID.quartzCoffeeTable,0,0,0,1,1/2,1);




// file: candlestick.js

createFurnitureLight("candlestick","candlestick","gold_block",0, "Candlestick", ItemID.candlestick, BlockID.candlestick);
Translation.addTranslation("Candlestick", {ru: "Подсвечник"});
Recipes.addShaped({id: IDData.item.candlestick, count: 1, data: 0}, ["ccc", "ggg", "vgv"], ["g",266,0,"c",263,0]);
Block.setShape(BlockID.candlestick,0,0,7.5/16,1,1,8.5/16);

var render = new ICRender.Model();
BlockRenderer.setStaticICRender (BlockID.candlestick, 0, render);
var model = BlockRenderer.createModel();
model.addBox (7/16, 0, 7/16, 9/16, 1/32, 9/16,  41, 0);
model.addBox (7.5/16, 0.01, 7.5/16, 8.5/16, 11/16, 8.5/16,  41, 0);
model.addBox (4/16, 6/16, 7.5/16, 12/16, 7/16, 8.5/16,  41, 0);

model.addBox (4/16, 7/16, 7.5/16, 5/16, 10/16, 8.5/16,  41, 0);
model.addBox (11/16, 7/16, 7.5/16, 12/16, 10/16, 8.5/16,  41, 0);

model.addBox (3.5/16, 9/16, 7/16, 5.5/16, 10/16, 9/16,  41, 0);
model.addBox (10.5/16, 9/16, 7/16, 12.5/16, 10/16, 9/16,  41, 0);
model.addBox (7/16, 11/16, 7/16, 9/16, 12/16, 9/16,  41, 0);

model.addBox (4/16, 10/16, 7.5/16, 5/16, 13/16, 8.5/16,  155, 0);
model.addBox (11/16, 10/16, 7.5/16, 12/16, 13/16, 8.5/16,  155, 0);
model.addBox (7.5/16, 12/16, 7.5/16, 8.5/16, 15/16, 8.5/16,  155, 0);

model.addBox (4.4/16, 13/16, 7.9/16, 4.6/16, 13.4/16, 8.1/16,  173, 0);
model.addBox (11.4/16, 13/16, 7.9/16, 11.6/16, 13.4/16, 8.1/16,  173, 0);
model.addBox (7.9/16, 15/16, 7.9/16, 8.1/16, 15.4/16, 8.1/16,  173, 0);

render.addEntry(model);
Item.registerUseFunction("candlestick", function(coords, item, block){
	World.setBlock(coords.relative.x,coords.relative.y,coords.relative.z, BlockID.candlestick);
	World.addTileEntity(coords.relative.x,coords.relative.y,coords.relative.z);
});
TileEntity.registerPrototype(BlockID.candlestick, {
	init:function(){
		if(World.getBlock(this.x, this.y-1, this.z).id==0){
			World.destroyBlock(this.x, this.y, this.z, true);
			World.removeTileEntity(this.x, this.y, this.z);
		}
	},
	tick:function(){
		if(World.getWorldTime()%20==0&&World.getBlock(this.x, this.y-1, this.z).id==0){
			World.destroyBlock(this.x, this.y, this.z, true);
			World.removeTileEntity(this.x, this.y, this.z);
		}
		if(World.getWorldTime()%15==0){
			var random = Math.floor(Math.random()*3);
			if(random==0){
				Particles.addFarParticle(7,this.x+0.5, this.y+1.07, this.z+0.5);
			}else if (random ==1){
				Particles.addFarParticle(7,this.x+4.5/16, this.y+15.5/16, this.z+0.5);
			}else{
				Particles.addFarParticle(7,this.x+11.5/16, this.y+15.5/16, this.z+0.5);
			}
		}
	}
});




// file: lantern.js

createFurnitureLight("lantern","lamp","stone",6, "Lantern", ItemID.lantern, BlockID.lantern);
Translation.addTranslation("Lantern", {ru: "Ручной Фонарь"});
Recipes.addShaped({id: IDData.item.lantern, count: 1, data: 0}, ["viv", "ici", "ici"], ["i",265,0, "c",263,0]);
Block.setShape(BlockID.lantern,5/16,0,5/16,11/16,1,11/16);


Item.registerUseFunction("lantern", function(coords, item, block){
	World.setBlock(coords.relative.x,coords.relative.y,coords.relative.z, BlockID.lantern);
	World.addTileEntity(coords.relative.x,coords.relative.y,coords.relative.z);
	World.getTileEntity(coords.relative.x,coords.relative.y,coords.relative.z).data.side=coords.side;
});


var render = new ICRender.Model();
var renderUp = new ICRender.Model();
var renderRight = new ICRender.Model();
var renderLeft = new ICRender.Model();
var renderFront = new ICRender.Model();
var renderBack = new ICRender.Model();
BlockRenderer.setStaticICRender (BlockID.lantern, 0, render);
var model = BlockRenderer.createModel();
var modelUp = BlockRenderer.createModel();
var modelFront = BlockRenderer.createModel();
var modelBack = BlockRenderer.createModel();
var modelRight = BlockRenderer.createModel();
var modelLeft = BlockRenderer.createModel();
model.addBox (5/16, 0, 5/16, 11/16, 1/16, 11/16,  1, 6);
model.addBox (6/16, 1/16, 6/16, 10/16, 2/16, 10/16,  1, 6);
model.addBox (7/16, 2/16, 7/16, 9/16, 3/16, 9/16,  1, 6);
model.addBox (6/16, 3/16, 6/16, 10/16, 6/16, 10/16,  [["glass_lanterne",0]]);
model.addBox (7/16, 6/16, 7/16, 9/16, 9/16, 9/16,  [["glass_lanterne",0]]);
model.addBox (6/16, 9/16, 6/16, 10/16, 10/16, 10/16,  1, 6);
model.addBox (7/16, 10/16, 7/16, 9/16, 11/16, 9/16,  1, 6);

model.addBox (5/16, 1/16, 7.5/16, 6/16, 2/16, 8.5/16,  1, 6);
model.addBox (10/16, 1/16, 7.5/16, 11/16, 2/16, 8.5/16,  1, 6);
model.addBox (4/16, 2/16, 7.5/16, 5/16, 7/16, 8.5/16,  1, 6);
model.addBox (11/16, 2/16, 7.5/16, 12/16, 7/16, 8.5/16,  1, 6);
model.addBox (5/16, 7/16, 7.5/16, 6/16, 9/16, 8.5/16,  1, 6);
model.addBox (10/16, 7/16, 7.5/16, 11/16, 9/16, 8.5/16,  1, 6);

model.addBox (5/16, 10/16, 7.5/16, 6/16, 12/16, 8.5/16,  1, 6);
model.addBox (10/16, 10/16, 7.5/16, 11/16, 12/16, 8.5/16,  1, 6);
model.addBox (6/16, 12/16, 7.5/16, 7/16, 13/16, 8.5/16,  1, 6);
model.addBox (9/16, 12/16, 7.5/16, 10/16, 13/16, 8.5/16,  1, 6);
model.addBox (7/16, 12/16, 7.5/16, 9/16, 13/16, 8.5/16,  [["stained_clay",12]]);



modelUp.addBox (5/16, 1/4, 5/16, 11/16, 5/16, 11/16,  1, 6);
modelUp.addBox (6/16, 5/16, 6/16, 10/16, 6/16, 10/16,  1, 6);
modelUp.addBox (7/16, 6/16, 7/16, 9/16, 7/16, 9/16,  1, 6);
modelUp.addBox (6/16, 7/16, 6/16, 10/16, 10/16, 10/16,  [["glass_lanterne",0]]);
modelUp.addBox (7/16, 10/16, 7/16, 9/16, 13/16, 9/16,  [["glass_lanterne",0]]);
modelUp.addBox (6/16, 13/16, 6/16, 10/16, 14/16, 10/16,  1, 6);
modelUp.addBox (7/16, 14/16, 7/16, 9/16, 15/16, 9/16,  1, 6);

modelUp.addBox (5/16, 5/16, 7.5/16, 6/16, 6/16, 8.5/16,  1, 6);
modelUp.addBox (10/16, 5/16, 7.5/16, 11/16, 6/16, 8.5/16,  1, 6);
modelUp.addBox (4/16, 6/16, 7.5/16, 5/16, 11/16, 8.5/16,  1, 6);
modelUp.addBox (11/16, 6/16, 7.5/16, 12/16, 11/16, 8.5/16,  1, 6);
modelUp.addBox (5/16, 11/16, 7.5/16, 6/16, 13/16, 8.5/16,  1, 6);
modelUp.addBox (10/16, 11/16, 7.5/16, 11/16, 13/16, 8.5/16,  1, 6);
modelUp.addBox (5/16, 14/16, 7.5/16, 6/16, 16/16, 8.5/16,  1, 6);
modelUp.addBox (10/16, 14/16, 7.5/16, 11/16, 16/16, 8.5/16,  1, 6);


modelFront.addBox (5/16, 0, 10/16, 11/16, 1/16, 16/16,  1, 6);
modelFront.addBox (6/16, 1/16, 11/16, 10/16, 2/16, 15/16,  1, 6);
modelFront.addBox (7/16, 2/16, 12/16, 9/16, 3/16, 14/16,  1, 6);
modelFront.addBox (6/16, 3/16, 11/16, 10/16, 6/16, 15/16,  [["glass_lanterne",0]]);
modelFront.addBox (7/16, 6/16, 12/16, 9/16, 9/16, 14/16,  [["glass_lanterne",0]]);
modelFront.addBox (6/16, 9/16, 11/16, 10/16, 10/16, 15/16,  1, 6);
modelFront.addBox (7/16, 10/16, 12/16, 9/16, 11/16, 14/16,  1, 6);

modelFront.addBox (5/16, 1/16, 12.5/16, 6/16, 2/16, 13.5/16,  1, 6);
modelFront.addBox (10/16, 1/16, 12.5/16, 11/16, 2/16, 13.5/16,  1, 6);
modelFront.addBox (4/16, 2/16, 12.5/16, 5/16, 7/16, 13.5/16,  1, 6);
modelFront.addBox (11/16, 2/16, 12.5/16, 12/16, 7/16, 13.5/16,  1, 6);
modelFront.addBox (5/16, 7/16, 12.5/16, 6/16, 9/16, 13.5/16,  1, 6);
modelFront.addBox (10/16, 7/16, 12.5/16, 11/16, 9/16, 13.5/16,  1, 6);

modelFront.addBox (5/16, 10/16, 12.5/16, 6/16, 12/16, 13.5/16,  1, 6);
modelFront.addBox (10/16, 10/16, 12.5/16, 11/16, 12/16, 13.5/16,  1, 6);
modelFront.addBox (6/16, 12/16, 12.5/16, 7/16, 13/16, 13.5/16,  1, 6);
modelFront.addBox (9/16, 12/16, 12.5/16, 10/16, 13/16, 13.5/16,  1, 6);
modelFront.addBox (7/16, 12/16, 12.5/16, 9/16, 13/16, 13.5/16,  [["stained_clay",12]]);
modelFront.addBox (7.5/16, 11.5/16, 12/16, 8.5/16, 12/16, 1, 5,0);
modelFront.addBox (7.5/16, 12/16, 12/16, 8.5/16, 12.5/16, 12.5/16, 5,0);



modelBack.addBox (5/16, 0, 0, 11/16, 1/16, 6/16,  1, 6);
modelBack.addBox (6/16, 1/16, 1/16, 10/16, 2/16, 5/16,  1, 6);
modelBack.addBox (7/16, 2/16, 2/16, 9/16, 3/16, 4/16,  1, 6);
modelBack.addBox (6/16, 3/16, 1/16, 10/16, 6/16, 5/16,  [["glass_lanterne",0]]);
modelBack.addBox (7/16, 6/16, 2/16, 9/16, 9/16, 4/16,  [["glass_lanterne",0]]);
modelBack.addBox (6/16, 9/16, 1/16, 10/16, 10/16, 5/16,  1, 6);
modelBack.addBox (7/16, 10/16, 2/16, 9/16, 11/16, 4/16,  1, 6);

modelBack.addBox (5/16, 1/16, 2.5/16, 6/16, 2/16, 3.5/16,  1, 6);
modelBack.addBox (10/16, 1/16,2.5/16, 11/16, 2/16, 3.5/16,  1, 6);
modelBack.addBox (4/16, 2/16, 2.5/16, 5/16, 7/16, 3.5/16,  1, 6);
modelBack.addBox (11/16, 2/16, 2.5/16, 12/16, 7/16, 3.5/16,  1, 6);
modelBack.addBox (5/16, 7/16, 2.5/16, 6/16, 9/16, 3.5/16,  1, 6);
modelBack.addBox (10/16, 7/16, 2.5/16, 11/16, 9/16, 3.5/16,  1, 6);

modelBack.addBox (5/16, 10/16, 2.5/16, 6/16, 12/16, 3.5/16,  1, 6);
modelBack.addBox (10/16, 10/16, 2.5/16, 11/16, 12/16, 3.5/16,  1, 6);
modelBack.addBox (6/16, 12/16, 2.5/16, 7/16, 13/16, 3.5/16,  1, 6);
modelBack.addBox (9/16, 12/16, 2.5/16, 10/16, 13/16, 3.5/16,  1, 6);
modelBack.addBox (7/16, 12/16, 2.5/16, 9/16, 13/16, 3.5/16,  [["stained_clay",12]]);
modelBack.addBox (7.5/16, 11.5/16, 0, 8.5/16, 12/16, 4/16, 5,0);
modelBack.addBox (7.5/16, 12/16, 3.5/16, 8.5/16, 12.5/16, 4/16, 5,0);



modelRight.addBox (0, 0, 5/16, 6/16, 1/16, 11/16,  1, 6);
modelRight.addBox (1/16, 1/16, 6/16, 5/16, 2/16, 10/16,  1, 6);
modelRight.addBox (2/16, 2/16, 7/16, 4/16, 3/16, 9/16,  1, 6);
modelRight.addBox (1/16, 3/16, 6/16, 5/16, 6/16, 10/16,  [["glass_lanterne",0]]);
modelRight.addBox (2/16, 6/16, 7/16, 4/16, 9/16, 9/16,  [["glass_lanterne",0]]);
modelRight.addBox (1/16, 9/16, 6/16, 5/16, 10/16, 10/16,  1, 6);
modelRight.addBox (2/16, 10/16, 7/16, 4/16, 11/16, 9/16,  1, 6);

modelRight.addBox (2.5/16, 1/16, 5/16, 3.5/16, 2/16, 6/16,  1, 6);
modelRight.addBox (2.5/16, 1/16,10/16, 3.5/16, 2/16, 11/16,  1, 6);
modelRight.addBox (2.5/16, 2/16, 4/16, 3.5/16, 7/16, 5/16,  1, 6);
modelRight.addBox (2.5/16, 2/16, 11/16, 3.5/16, 7/16, 12/16,  1, 6);
modelRight.addBox (2.5/16, 7/16, 5/16, 3.5/16, 9/16, 6/16,  1, 6);
modelRight.addBox (2.5/16, 7/16, 10/16, 3.5/16, 9/16, 11/16,  1, 6);

modelRight.addBox (2.5/16, 10/16, 5/16, 3.5/16, 12/16, 6/16,  1, 6);
modelRight.addBox (2.5/16, 10/16, 10/16, 3.5/16, 12/16, 11/16,  1, 6);
modelRight.addBox (2.5/16, 12/16, 6/16, 3.5/16, 13/16, 7/16,  1, 6);
modelRight.addBox (2.5/16, 12/16, 9/16, 3.5/16, 13/16, 10/16,  1, 6);
modelRight.addBox (2.5/16, 12/16, 7/16, 3.5/16, 13/16, 9/16,  [["stained_clay",12]]);
modelRight.addBox (0, 11.5/16, 7.5/16, 4/16, 12/16, 8.5/16, 5,0);
modelRight.addBox (3.5/16, 12/16, 7.5/16, 4/16, 12.5/16, 8.5/16, 5,0);



modelLeft.addBox (10/16, 0, 5/16, 16/16, 1/16, 11/16,  1, 6);
modelLeft.addBox (11/16, 1/16, 6/16, 15/16, 2/16, 10/16,  1, 6);
modelLeft.addBox (12/16, 2/16, 7/16, 14/16, 3/16, 9/16,  1, 6);
modelLeft.addBox (11/16, 3/16, 6/16, 15/16, 6/16, 10/16,  [["glass_lanterne",0]]);
modelLeft.addBox (12/16, 6/16, 7/16, 14/16, 9/16, 9/16,  [["glass_lanterne",0]]);
modelLeft.addBox (11/16, 9/16, 6/16, 15/16, 10/16, 10/16,  1, 6);
modelLeft.addBox (12/16, 10/16, 7/16, 14/16, 11/16, 9/16,  1, 6);

modelLeft.addBox (12.5/16, 1/16, 5/16, 13.5/16, 2/16, 6/16,  1, 6);
modelLeft.addBox (12.5/16, 1/16,10/16, 13.5/16, 2/16, 11/16,  1, 6);
modelLeft.addBox (12.5/16, 2/16, 4/16, 13.5/16, 7/16, 5/16,  1, 6);
modelLeft.addBox (12.5/16, 2/16, 11/16, 13.5/16, 7/16, 12/16,  1, 6);
modelLeft.addBox (12.5/16, 7/16, 5/16, 13.5/16, 9/16, 6/16,  1, 6);
modelLeft.addBox (12.5/16, 7/16, 10/16, 13.5/16, 9/16, 11/16,  1, 6);

modelLeft.addBox (12.5/16, 10/16, 5/16, 13.5/16, 12/16, 6/16,  1, 6);
modelLeft.addBox (12.5/16, 10/16, 10/16, 13.5/16, 12/16, 11/16,  1, 6);
modelLeft.addBox (12.5/16, 12/16, 6/16, 13.5/16, 13/16, 7/16,  1, 6);
modelLeft.addBox (12.5/16, 12/16, 9/16, 13.5/16, 13/16, 10/16,  1, 6);
modelLeft.addBox (12.5/16, 12/16, 7/16, 13.5/16, 13/16, 9/16,  [["stained_clay",12]]);
modelLeft.addBox (12/16, 11.5/16, 7.5/16, 1, 12/16, 8.5/16, 5,0);
modelLeft.addBox (12/16, 12/16, 7.5/16, 12.5/16, 12.5/16, 8.5/16, 5,0);

render.addEntry(model);
renderFront.addEntry(modelFront);
renderBack.addEntry(modelBack);
renderRight.addEntry(modelLeft);
renderLeft.addEntry(modelRight);
renderUp.addEntry(modelUp);
BlockRenderer.enableCoordMapping (BlockID.lantern, -1, render);

TileEntity.registerPrototype(BlockID.lantern, {
	init:function(){
		if(this.data.side==0){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, renderUp);
		}else if(this.data.side==2){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, renderFront);
		}else if(this.data.side==3){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, renderBack);
		}else if(this.data.side==4){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, renderRight);
		}else if(this.data.side==5){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, renderLeft);
		}
	},
	tick:function(){
		if(World.getWorldTime()%15==0){
			if(this.data.side==1){
				Particles.addFarParticle(7,this.x+.5, this.y+.3, this.z+.5);
				}else if(this.data.side==0){
					Particles.addFarParticle(7,this.x+.5, this.y+.7, this.z+.5);
				}else if(this.data.side==2){
					Particles.addFarParticle(7,this.x+.5, this.y+.3, this.z+.8);
				}else if(this.data.side==3){
					Particles.addFarParticle(7,this.x+.5, this.y+.3, this.z+.2);
				}else if(this.data.side==4){
					Particles.addFarParticle(7,this.x+.8, this.y+.3, this.z+.5);
				}else{
					Particles.addFarParticle(7,this.x+.2, this.y+.3, this.z+.5);
				}
		}
	}
});




// file: cooker.js

createFurnitureStone("cooker","cooker","quartz_block",0, "Cooker", ItemID.cooker, BlockID.cooker);
Translation.addTranslation("Cooker", {ru: "Кухонная Плита"});
Recipes.addShaped({id: IDData.item.cooker, count: 1, data: 0}, ["iii", "iii", "ibi"], ["i",265,0, "b",42,0]);
Item.registerUseFunction("cooker", function(coords, item, block){
	World.setBlock(coords.relative.x,coords.relative.y,coords.relative.z, BlockID.cooker);
	World.addTileEntity(coords.relative.x,coords.relative.y,coords.relative.z);
	var look = Entity.getLookVector(Player.get());
	if(look.x>.75){
		World.getTileEntity(coords.relative.x,coords.relative.y,coords.relative.z).data.orientation=1;
	}
	if(look.x<-.75){
		World.getTileEntity(coords.relative.x,coords.relative.y,coords.relative.z).data.orientation=3;
	}
	if(look.z>.75){
		World.getTileEntity(coords.relative.x,coords.relative.y,coords.relative.z).data.orientation=2;
	}
	if(look.z<-.75){
		World.getTileEntity(coords.relative.x,coords.relative.y,coords.relative.z).data.orientation=4;
	}
});
var render = new ICRender.Model();
var render1 = new ICRender.Model();
var render2 = new ICRender.Model();
var render3 = new ICRender.Model();
BlockRenderer.setStaticICRender (BlockID.cooker, 0, render);
var model = BlockRenderer.createModel();
var model1 = BlockRenderer.createModel();
var model2 = BlockRenderer.createModel();
var model3 = BlockRenderer.createModel();

var modelArray=ModelAPI.newArray();
modelArray.addBoxByID("mainBlock1", 0, 0, 0, 1, 2/16, 1, 155);
modelArray.addBoxByID("mainBlock2", 0, 12/16, 0, 1, 15/16, 1, 155);
modelArray.addBoxByID("mainBlock3", 0, 2/16, 0, 1, 12/16, 3/16, 155);
modelArray.addBoxByID("mainBlock4", 0, 2/16, 13/16, 1, 12/16, 1, 155);
modelArray.addBoxByID("mainBlock5", 14/16, 2/16, 3/16, 1, 12/16, 13/16, 155);

modelArray.addBoxByID("fire1", 3/16, 15/16, 3/16, 7/16, 1, 7/16, 173);
modelArray.addBoxByID("fire3", 9/16, 15/16, 9/16, 13/16, 1, 13/16, 173);
modelArray.addBoxByID("fire2", 3/16, 15/16, 9/16, 7/16, 1, 13/16, 173);
modelArray.addBoxByID("fire4", 9/16, 15/16, 3/16, 13/16, 1, 7/16, 173);
modelArray.addBoxByID("ledge1", 0, 15/16, 0, 1, 1, 1/16, 155);
modelArray.addBoxByID("ledge2", 0, 15/16, 15/16, 1, 1, 1, 155);
modelArray.addBoxByID("ledge3", 0, 15/16, 1/16, 1/16, 1, 15/16, 155);
modelArray.addBoxByID("ledge4", 15/16, 15/16, 1/16, 1, 1, 15/16, 155);

modelArray.addBoxByID("glass", -1/16, 3/16, 3/16, 0, 11/16, 13/16, 20);
modelArray.addBoxByID("ledgeGlass1", -1/16, 2/16, 2/16, 0, 3/16, 14/16, 155);
modelArray.addBoxByID("ledgeGlass2", -1/16, 11/16, 2/16, 0, 12/16, 14/16, 155);
modelArray.addBoxByID("ledgeGlass3", -1/16, 3/16, 2/16, 0, 11/16, 3/16, 155);
modelArray.addBoxByID("ledgeGlass4", -1/16, 3/16, 13/16, 0, 11/16, 14/16, 155);

modelArray.addBoxByID("1", -2/16, 11/16, 6/16, -1/16, 12/16, 10/16, 173);

modelArray.addBoxByID("2", -.3/16, 12.5/16, 1/16, 0, 14.5/16, 3/16, 44);
modelArray.addBoxByID("3", -.3/16, 12.5/16, 4/16, 0, 14.5/16, 6/16, 44);
modelArray.addBoxByID("4", -.3/16, 12.5/16, 7/16, 0, 14.5/16, 9/16, 44);
modelArray.addBoxByID("5", -.3/16, 12.5/16, 10/16, 0, 14.5/16, 12/16, 44);

modelArray.addBoxByID("6", -.5/16, 12.5/16, 14/16, 0, 13.5/16, 15/16, 35, 5);
modelArray.addBoxByID("7", -.5/16, 13.5/16, 14/16, 0, 14.5/16, 15/16, 35, 14);

for(var i = 3; i<14; i+=2){
	modelArray.addBoxByID("rod"+i, i/16, 5/16, 3/16, (i+1)/16, 5.3/16, 13/16, 44);
}

modelArray.compile(model);
modelArray.rotation("all", "y",90,{x:.5, y:.5, z:.5});
modelArray.compile(model1);
modelArray.rotation("all", "y",180,{x:.5, y:.5, z:.5});
modelArray.compile(model2);
modelArray.rotation("all", "y",90,{x:.5, y:.5, z:.5});
modelArray.compile(model3);
render.addEntry(model);
render1.addEntry(model1);
render2.addEntry(model2);
render3.addEntry(model3);
var FURNACE_FUEL_MAP = {
	5: 300,
	6: 100,
	17: 300,
	263: 1600,
	280: 100,
	268: 200,
	269: 200,
	270: 200,
	271: 200,
	85: 300,
	107: 300,
	134: 300,
	135: 300,
	158: 150,
	162: 300,
	163: 300,
	164: 300,
	184: 300,
	185: 300,
	186: 300,
	187: 300,
	53: 300,
	54: 300,
	58: 300
};
BlockRenderer.enableCoordMapping (BlockID.cooker, -1, render);
var GUI_BAR_STANDART_SCALE=3.2;
var guiCooker = new UI.StandartWindow({
	standart: {
		header: {text: {text: "Cooker"}},
		inventory: {standart: true},
		background: {standart: true}
	},
	
	drawing: [
		{type: "bitmap", x: 530, y: 146, bitmap: "furnace_bar_background", scale: GUI_BAR_STANDART_SCALE},
		{type: "bitmap", x: 450, y: 150, bitmap: "fire_background", scale: GUI_BAR_STANDART_SCALE}
	],
	
	elements: {
		"progressScale": {type: "scale", x: 530, y: 146, direction: 0, value: 0.5, bitmap: "furnace_bar_scale", scale: GUI_BAR_STANDART_SCALE},
		"burningScale": {type: "scale", x: 450, y: 150, direction: 1, value: 0.5, bitmap: "fire_scale", scale: GUI_BAR_STANDART_SCALE},
		"slotSource": {type: "slot", x: 441, y: 75},
		"slotFuel": {type: "slot", x: 441, y: 212},
		"slotResult": {type: "slot", x: 625, y: 142},
	}
});
TileEntity.registerPrototype(BlockID.cooker, {
	init:function(){
		this.animationDown = new Animation.Item(this.x+.5, this.y+.18, this.z+.5);
		this.animationUp = new Animation.Item(this.x+.5, this.y+.38, this.z+.5);
		if(this.data.orientation==1){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, render);
		}else if(this.data.orientation==2){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, render2);
		}else if(this.data.orientation==3){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, render3);
		}else if(this.data.orientation==4){
			BlockRenderer.mapAtCoords (this.x, this.y, this.z, render1);
		}
	},
	defaultValues: {
		progress: 0,
		burn: 0,
		burnMax: 0
	},
	
	getGuiScreen: function(){
		return guiCooker;
	},
	
	tick:function(){
		var sourceSlot = this.container.getSlot("slotSource");
		var resultSlot = this.container.getSlot("slotResult");
		if(World.getWorldTime()%2==0){
			if(sourceSlot.id!=0){
				this.animationDown.describeItem({
			id: sourceSlot.id,
			count: 1,
			data: sourceSlot.data,
			size: .5,
			rotation:[3.14/2, 0, 0]
		});
		this.animationDown.load();
			}else {
				this.animationDown.destroy();
			}
			if(resultSlot.id!=0){
				this.animationUp.describeItem({
			id: resultSlot.id,
			count: 1,
			data: resultSlot.data,
			size: .5,
			rotation:[3.14/2, 0, 0]
		});
		this.animationUp.load();
			}else{
				this.animationUp.destroy();
			}
		}
	
		var result = Recipes.getFurnaceRecipeResult(sourceSlot.id, "iron");
		if(result && this.data.burn > 0){
			
			if((resultSlot.id == result.id && resultSlot.data == result.data && resultSlot.count < 64 || resultSlot.id == 0) && this.data.progress++ >= 160){
				sourceSlot.count--;
				resultSlot.id = result.id;
				resultSlot.data = result.data;
				resultSlot.count++;
				this.container.validateAll();
				this.data.progress = 0;
			}
		}
		else {
			this.data.progress = 0;
		}
		
		if(this.data.burn > 0){
			this.data.burn--;
		}
		else if(result){
			this.data.burn = this.data.burnMax = this.getFuel("slotFuel");
		}
		
		this.container.setScale("burningScale", this.data.burn / this.data.burnMax || 0);
		this.container.setScale("progressScale", this.data.progress / 160);
	},
	
	getFuel: function(slotName){
		var fuelSlot = this.container.getSlot(slotName);
		if(fuelSlot.id > 0){
			var burn = FURNACE_FUEL_MAP[fuelSlot.id];
			if(burn){
				fuelSlot.count--;
				this.container.validateSlot(slotName);
				return burn;
			}
			if(LiquidRegistry.getItemLiquid(fuelSlot.id, fuelSlot.data) == "lava"){
				var empty = LiquidRegistry.getEmptyItem(fuelSlot.id, fuelSlot.data);
				fuelSlot.id = empty.id;
				fuelSlot.data = empty.data;
				return 20000;
			}
		}
		return 0;
	}
});




